"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorFormatter = void 0;
const chalk = require("chalk");
const expected = chalk.green;
const received = chalk.redBright;
const typeComparison1 = (ss, p1) => ss.replace(`'${p1}'`, `'${received(p1)}'`);
const typeComparison2 = (ss, p1, p2) => ss
    .replace(`'${p1}'`, `'${received(p1)}'`)
    .replace(`'${p2}'`, `'${expected(p2)}'`);
const typeComparison3 = (ss, p1, p2, p3) => ss
    .replace(`'${p1}'`, `'${received(p1)}'`)
    .replace(`'${p2}'`, `'${received(p2)}'`)
    .replace(`'${p3}'`, `'${expected(p3)}'`);
const highlights = [
    [/.+ '(.+)' .+ '(.+)' .+ '(.+)'.*/, typeComparison3],
    [/.+ '(.+)' .+ '(.+)'.*/, typeComparison2],
    [/.+ '(.+)' .+\./, typeComparison1],
];
const errorFormatter = (msg) => highlights.reduce((m, h) => m.replace(new RegExp(h[0], 'g'), h[1]), msg);
exports.errorFormatter = errorFormatter;
//# sourceMappingURL=errorFormatter.js.map